package org.bench4q.share.models.agent;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name = "BehaviorStatusCodeResultModel")
public class BehaviorStatusCodeResultModel {
	private int statusCode;
	private long count;
	private String contentType;
	private long contentLength;
	private long minResponseTime;
	private long maxResponseTime;
	private long totalResponseTimeThisTime;

	@XmlElement
	public int getStatusCode() {
		return statusCode;
	}

	public void setStatusCode(int statusCode) {
		this.statusCode = statusCode;
	}

	@XmlElement
	public long getCount() {
		return count;
	}

	public void setCount(long count) {
		this.count = count;
	}

	@XmlElement
	public String getContentType() {
		return contentType;
	}

	public void setContentType(String contentType) {
		this.contentType = contentType;
	}

	@XmlElement
	public long getContentLength() {
		return contentLength;
	}

	public void setContentLength(long contentLength) {
		this.contentLength = contentLength;
	}

	@XmlElement
	public long getMinResponseTime() {
		return minResponseTime;
	}

	public void setMinResponseTime(long minResponseTime) {
		this.minResponseTime = minResponseTime;
	}

	@XmlElement
	public long getMaxResponseTime() {
		return maxResponseTime;
	}

	public void setMaxResponseTime(long maxResponseTime) {
		this.maxResponseTime = maxResponseTime;
	}

	@XmlElement
	public long getTotalResponseTimeThisTime() {
		return totalResponseTimeThisTime;
	}

	public void setTotalResponseTimeThisTime(long totalResponseTimeThisTime) {
		this.totalResponseTimeThisTime = totalResponseTimeThisTime;
	}

	/**
	 * It's just the http's success judgement, if we'll turn to other protocal,
	 * we should build a inheritance system
	 * 
	 * @return
	 */
	public boolean isSuccess() {
		return this.getStatusCode() == 200;
	}

	public BehaviorStatusCodeResultModel getCopy() {
		BehaviorStatusCodeResultModel ret = new BehaviorStatusCodeResultModel();
		ret.setStatusCode(getStatusCode());
		ret.setContentLength(getContentLength());
		ret.setContentType(getContentType());
		ret.setCount(getCount());
		ret.setMaxResponseTime(getMaxResponseTime());
		ret.setMinResponseTime(getMinResponseTime());
		ret.setTotalResponseTimeThisTime(getTotalResponseTimeThisTime());
		return ret;
	}

	public synchronized void plus(BehaviorStatusCodeResultModel newOne) {
		this.setContentLength(this.getContentLength()
				+ newOne.getContentLength());
		this.setCount(this.getCount() + newOne.getCount());
		this.setTotalResponseTimeThisTime(this.getTotalResponseTimeThisTime()
				+ newOne.getTotalResponseTimeThisTime());
		if (newOne.getMaxResponseTime() > this.getMaxResponseTime()) {
			this.setMaxResponseTime(newOne.getMaxResponseTime());
		}
		if (newOne.getMinResponseTime() < this.getMinResponseTime()) {
			this.setMinResponseTime(newOne.getMinResponseTime());
		}
	}
}
